// SPDX-License-Identifier: GPL-3.0

/*
    This file is part of the Enzyme Protocol.

    (c) Enzyme Council <councilenzyme.finance>

    For the full license information, please view the LICENSE
    file that was distributed with this source code.
*/

pragma solidity ^0.6.12;

import "./GasRelayPaymasterLibBase1.sol";

/// title GasRelayPaymasterLibBase2 Contract
/// author Enzyme Council <securityenzyme.finance>
/// notice A persistent contract containing all required storage variables and events
/// for a GasRelayPaymasterLib
/// dev DO NOT EDIT CONTRACT ONCE DEPLOYED. If new events or storage are necessary,
/// they should be added to a numbered GasRelayPaymasterLibBaseXXX that inherits the previous base.
/// e.g., `GasRelayPaymasterLibBase2 is GasRelayPaymasterLibBase1`
abstract contract GasRelayPaymasterLibBase2 is GasRelayPaymasterLibBase1 {
    uint256 internal lastDepositTimestamp;
}
