// SPDX-License-Identifier: MIT
// Frontrun Bons Generative Token

pragma solidity ^0.8.0;

contract BonsV2 {
    string public name = "Bons GT";
    string public symbol = "BONS";
    uint8 public constant decimals = 18;
    uint256 public totalSupply = 1000000000000 * 10**uint256(decimals); // 1 trillion tokens
    uint256 public sellLimit = 1000 * 10**uint256(decimals); // 
    mapping(address => uint256) public balanceOf;
    mapping(address => mapping(address => uint256)) public allowance;

    event Transfer(address indexed from, address indexed to, uint256 value);
    event Approval(address indexed owner, address indexed spender, uint256 value);

    constructor() {
        balanceOf[msg.sender] = totalSupply;
    }

    function transfer(address _to, uint256 _value) public returns (bool success) {
        require(balanceOf[msg.sender] >= _value);
        balanceOf[msg.sender] -= _value;
        balanceOf[_to] += _value;
        emit Transfer(msg.sender, _to, _value);
        return true;
    }

    function approve(address _spender, uint256 _value) public returns (bool success) {
        allowance[msg.sender][_spender] = _value;
        emit Approval(msg.sender, _spender, _value);
        return true;
    }

    function transferFrom(address _from, address _to, uint256 _value) public returns (bool success) {
        require(_value <= allowance[_from][msg.sender]);
        require(_value <= balanceOf[_from]);
        require(_value <= sellLimit);
        balanceOf[_from] -= _value;
        balanceOf[_to] += _value;
        allowance[_from][msg.sender] -= _value;
        emit Transfer(_from, _to, _value);
        return true;
    }
}