// SPDX-License-Identifier: GPL-3.0

pragma solidity >=0.5.0;

/// title Pool state that never changes
/// notice These parameters are fixed for a pool forever, i.e., the methods will always return the same values
interface IUniswapV3Pool {
    /// notice The first of the two tokens of the pool, sorted by address
    /// return The token contract address
    function token0() external view returns (address);

    /// notice The second of the two tokens of the pool, sorted by address
    /// return The token contract address
    function token1() external view returns (address);

    /// notice The pool's fee in hundredths of a bip, i.e. 1e-6
    /// return The fee
    function fee() external view returns (uint24);
}
