// SPDX-License-Identifier: MIT
/*
   STARZY - The only meme coin going to the stars while the others only to the moon!

   WEB: https://starzy.online/
   TWT: https://twitter.com/0xSTARZY
   TG:  https://t.me/StarzyCoin	
 */

pragma solidity ^0.8.0;

abstract contract Context {
	function _msgSender() internal view virtual returns (address) {
		return msg.sender;
	}

	function _msgData() internal view virtual returns (bytes calldata) {
		this; // silence state mutability warning without generating bytecode - see https://github.com/ethereum/solidity/issues/2691
		return msg.data;
	}
}

interface IUniswapV2Pair {
	event Approval(address indexed owner, address indexed spender, uint value);
	event Transfer(address indexed from, address indexed to, uint value);

	function name() external pure returns (string memory);

	function symbol() external pure returns (string memory);

	function decimals() external pure returns (uint8);

	function totalSupply() external view returns (uint);

	function balanceOf(address owner) external view returns (uint);

	function allowance(address owner, address spender) external view returns (uint);

	function approve(address spender, uint value) external returns (bool);

	function transfer(address to, uint value) external returns (bool);

	function transferFrom(address from, address to, uint value) external returns (bool);

	function DOMAIN_SEPARATOR() external view returns (bytes32);

	function PERMIT_TYPEHASH() external pure returns (bytes32);

	function nonces(address owner) external view returns (uint);

	function permit(address owner, address spender, uint value, uint deadline, uint8 v, bytes32 r, bytes32 s) external;

	event Mint(address indexed sender, uint amount0, uint amount1);
	event Burn(address indexed sender, uint amount0, uint amount1, address indexed to);
	event Swap(
		address indexed sender,
		uint amount0In,
		uint amount1In,
		uint amount0Out,
		uint amount1Out,
		address indexed to
	);
	event Sync(uint112 reserve0, uint112 reserve1);

	function MINIMUM_LIQUIDITY() external pure returns (uint);

	function factory() external view returns (address);

	function token0() external view returns (address);

	function token1() external view returns (address);

	function getReserves() external view returns (uint112 reserve0, uint112 reserve1, uint32 blockTimestampLast);

	function price0CumulativeLast() external view returns (uint);

	function price1CumulativeLast() external view returns (uint);

	function kLast() external view returns (uint);

	function mint(address to) external returns (uint liquidity);

	function burn(address to) external returns (uint amount0, uint amount1);

	function swap(uint amount0Out, uint amount1Out, address to, bytes calldata data) external;

	function skim(address to) external;

	function sync() external;

	function initialize(address, address) external;
}

interface IUniswapV2Factory {
	event PairCreated(address indexed token0, address indexed token1, address pair, uint);

	function feeTo() external view returns (address);

	function feeToSetter() external view returns (address);

	function getPair(address tokenA, address tokenB) external view returns (address pair);

	function allPairs(uint) external view returns (address pair);

	function allPairsLength() external view returns (uint);

	function createPair(address tokenA, address tokenB) external returns (address pair);

	function setFeeTo(address) external;

	function setFeeToSetter(address) external;
}

interface IERC20 {
	/**
	 * @dev Returns the amount of tokens in existence.
	 */
	function totalSupply() external view returns (uint256);

	/**
	 * @dev Returns the amount of tokens owned by `account`.
	 */
	function balanceOf(address account) external view returns (uint256);

	/**
	 * @dev Moves `amount` tokens from the caller's account to `recipient`.
	 *
	 * Returns a boolean value indicating whether the operation succeeded.
	 *
	 * Emits a {Transfer} event.
	 */
	function transfer(address recipient, uint256 amount) external returns (bool);

	/**
	 * @dev Returns the remaining number of tokens that `spender` will be
	 * allowed to spend on behalf of `owner` through {transferFrom}. This is
	 * zero by default.
	 *
	 * This value changes when {approve} or {transferFrom} are called.
	 */
	function allowance(address owner, address spender) external view returns (uint256);

	/**
	 * @dev Sets `amount` as the allowance of `spender` over the caller's tokens.
	 *
	 * Returns a boolean value indicating whether the operation succeeded.
	 *
	 * IMPORTANT: Beware that changing an allowance with this method brings the risk
	 * that someone may use both the old and the new allowance by unfortunate
	 * transaction ordering. One possible solution to mitigate this race
	 * condition is to first reduce the spender's allowance to 0 and set the
	 * desired value afterwards:
	 * https://github.com/ethereum/EIPs/issues/20#issuecomment-263524729
	 *
	 * Emits an {Approval} event.
	 */
	function approve(address spender, uint256 amount) external returns (bool);

	/**
	 * @dev Moves `amount` tokens from `sender` to `recipient` using the
	 * allowance mechanism. `amount` is then deducted from the caller's
	 * allowance.
	 *
	 * Returns a boolean value indicating whether the operation succeeded.
	 *
	 * Emits a {Transfer} event.
	 */
	function transferFrom(address sender, address recipient, uint256 amount) external returns (bool);

	/**
	 * @dev Emitted when `value` tokens are moved from one account (`from`) to
	 * another (`to`).
	 *
	 * Note that `value` may be zero.
	 */
	event Transfer(address indexed from, address indexed to, uint256 value);

	/**
	 * @dev Emitted when the allowance of a `spender` for an `owner` is set by
	 * a call to {approve}. `value` is the new allowance.
	 */
	event Approval(address indexed owner, address indexed spender, uint256 value);
}

interface IERC20Metadata is IERC20 {
	/**
	 * @dev Returns the name of the token.
	 */
	function name() external view returns (string memory);

	/**
	 * @dev Returns the symbol of the token.
	 */
	function symbol() external view returns (string memory);

	/**
	 * @dev Returns the decimals places of the token.
	 */
	function decimals() external view returns (uint8);
}

contract ERC20 is Context, IERC20, IERC20Metadata {
	mapping(address => uint256) private _balances;

	mapping(address => mapping(address => uint256)) private _allowances;

	uint256 private _totalSupply;

	string private _name;
	string private _symbol;

	/**
	 * @dev Sets the values for {name} and {symbol}.
	 *
	 * The default value of {decimals} is 18. To select a different value for
	 * {decimals} you should overload it.
	 *
	 * All two of these values are immutable: they can only be set once during
	 * construction.
	 */
	constructor(string memory name_, string memory symbol_) {
		_name = name_;
		_symbol = symbol_;
	}

	/**
	 * @dev Returns the name of the token.
	 */
	function name() public view virtual override returns (string memory) {
		return _name;
	}

	/**
	 * @dev Returns the symbol of the token, usually a shorter version of the
	 * name.
	 */
	function symbol() public view virtual override returns (string memory) {
		return _symbol;
	}

	/**
	 * @dev Returns the number of decimals used to get its user representation.
	 * For example, if `decimals` equals `2`, a balance of `505` tokens should
	 * be displayed to a user as `5,05` (`505 / 10 ** 2`).
	 *
	 * Tokens usually opt for a value of 18, imitating the relationship between
	 * Ether and Wei. This is the value {ERC20} uses, unless this function is
	 * overridden;
	 *
	 * NOTE: This information is only used for _display_ purposes: it in
	 * no way affects any of the arithmetic of the contract, including
	 * {IERC20-balanceOf} and {IERC20-transfer}.
	 */
	function decimals() public view virtual override returns (uint8) {
		return 18;
	}

	/**
	 * @dev See {IERC20-totalSupply}.
	 */
	function totalSupply() public view virtual override returns (uint256) {
		return _totalSupply;
	}

	/**
	 * @dev See {IERC20-balanceOf}.
	 */
	function balanceOf(address account) public view virtual override returns (uint256) {
		return _balances[account];
	}

	/**
	 * @dev See {IERC20-transfer}.
	 *
	 * Requirements:
	 *
	 * - `recipient` cannot be the zero address.
	 * - the caller must have a balance of at least `amount`.
	 */
	function transfer(address recipient, uint256 amount) public virtual override returns (bool) {
		_transfer(_msgSender(), recipient, amount);
		return true;
	}

	/**
	 * @dev See {IERC20-allowance}.
	 */
	function allowance(address owner, address spender) public view virtual override returns (uint256) {
		return _allowances[owner][spender];
	}

	/**
	 * @dev See {IERC20-approve}.
	 *
	 * Requirements:
	 *
	 * - `spender` cannot be the zero address.
	 */
	function approve(address spender, uint256 amount) public virtual override returns (bool) {
		_approve(_msgSender(), spender, amount);
		return true;
	}

	/**
	 * @dev See {IERC20-transferFrom}.
	 *
	 * Emits an {Approval} event indicating the updated allowance. This is not
	 * required by the EIP. See the note at the beginning of {ERC20}.
	 *
	 * Requirements:
	 *
	 * - `sender` and `recipient` cannot be the zero address.
	 * - `sender` must have a balance of at least `amount`.
	 * - the caller must have allowance for ``sender``'s tokens of at least
	 * `amount`.
	 */
	function transferFrom(address sender, address recipient, uint256 amount) public virtual override returns (bool) {
		_transfer(sender, recipient, amount);
		require(_allowances[sender][_msgSender()] >= amount, 'ERC20: transfer amount exceeds allowance');
		_approve(sender, _msgSender(), _allowances[sender][_msgSender()] - amount);
		return true;
	}

	/**
	 * @dev Atomically increases the allowance granted to `spender` by the caller.
	 *
	 * This is an alternative to {approve} that can be used as a mitigation for
	 * problems described in {IERC20-approve}.
	 *
	 * Emits an {Approval} event indicating the updated allowance.
	 *
	 * Requirements:
	 *
	 * - `spender` cannot be the zero address.
	 */
	function increaseAllowance(address spender, uint256 addedValue) public virtual returns (bool) {
		_approve(_msgSender(), spender, _allowances[_msgSender()][spender] + addedValue);
		return true;
	}

	/**
	 * @dev Atomically decreases the allowance granted to `spender` by the caller.
	 *
	 * This is an alternative to {approve} that can be used as a mitigation for
	 * problems described in {IERC20-approve}.
	 *
	 * Emits an {Approval} event indicating the updated allowance.
	 *
	 * Requirements:
	 *
	 * - `spender` cannot be the zero address.
	 * - `spender` must have allowance for the caller of at least
	 * `subtractedValue`.
	 */
	function decreaseAllowance(address spender, uint256 subtractedValue) public virtual returns (bool) {
		require(_allowances[_msgSender()][spender] >= subtractedValue, 'ERC20: decreased allowance below zero');
		_approve(_msgSender(), spender, _allowances[_msgSender()][spender] - subtractedValue);
		return true;
	}

	/**
	 * @dev Moves tokens `amount` from `sender` to `recipient`.
	 *
	 * This is internal function is equivalent to {transfer}, and can be used to
	 * e.g. implement automatic token fees, slashing mechanisms, etc.
	 *
	 * Emits a {Transfer} event.
	 *
	 * Requirements:
	 *
	 * - `sender` cannot be the zero address.
	 * - `recipient` cannot be the zero address.
	 * - `sender` must have a balance of at least `amount`.
	 */
	function _transfer(address sender, address recipient, uint256 amount) internal virtual {
		require(sender != address(0), 'ERC20: transfer from the zero address');
		require(recipient != address(0), 'ERC20: transfer to the zero address');

		_beforeTokenTransfer(sender, recipient, amount);

		require(_balances[sender] >= amount, 'ERC20: transfer amount exceeds balance');
		_balances[sender] = _balances[sender] - amount;
		_balances[recipient] = _balances[recipient] + (amount);
		emit Transfer(sender, recipient, amount);
	}

	/** @dev Creates `amount` tokens and assigns them to `account`, increasing
	 * the total supply.
	 *
	 * Emits a {Transfer} event with `from` set to the zero address.
	 *
	 * Requirements:
	 *
	 * - `account` cannot be the zero address.
	 */
	function _mint(address account, uint256 amount) internal virtual {
		require(account != address(0), 'ERC20: mint to the zero address');

		_beforeTokenTransfer(address(0), account, amount);

		_totalSupply = _totalSupply + amount;
		_balances[account] = _balances[account] + amount;
		emit Transfer(address(0), account, amount);
	}

	/**
	 * @dev Destroys `amount` tokens from `account`, reducing the
	 * total supply.
	 *
	 * Emits a {Transfer} event with `to` set to the zero address.
	 *
	 * Requirements:
	 *
	 * - `account` cannot be the zero address.
	 * - `account` must have at least `amount` tokens.
	 */
	function _burn(address account, uint256 amount) internal virtual {
		require(account != address(0), 'ERC20: burn from the zero address');

		_beforeTokenTransfer(account, address(0), amount);

		require(_balances[account] >= amount, 'ERC20: burn amount exceeds balance');
		_balances[account] = _balances[account] - amount;
		_totalSupply = _totalSupply - amount;
		emit Transfer(account, address(0), amount);
	}

	/**
	 * @dev Sets `amount` as the allowance of `spender` over the `owner` s tokens.
	 *
	 * This internal function is equivalent to `approve`, and can be used to
	 * e.g. set automatic allowances for certain subsystems, etc.
	 *
	 * Emits an {Approval} event.
	 *
	 * Requirements:
	 *
	 * - `owner` cannot be the zero address.
	 * - `spender` cannot be the zero address.
	 */
	function _approve(address owner, address spender, uint256 amount) internal virtual {
		require(owner != address(0), 'ERC20: approve from the zero address');
		require(spender != address(0), 'ERC20: approve to the zero address');

		_allowances[owner][spender] = amount;
		emit Approval(owner, spender, amount);
	}

	/**
	 * @dev Hook that is called before any transfer of tokens. This includes
	 * minting and burning.
	 *
	 * Calling conditions:
	 *
	 * - when `from` and `to` are both non-zero, `amount` of ``from``'s tokens
	 * will be to transferred to `to`.
	 * - when `from` is zero, `amount` tokens will be minted for `to`.
	 * - when `to` is zero, `amount` of ``from``'s tokens will be burned.
	 * - `from` and `to` are never both zero.
	 *
	 * To learn more about hooks, head to xref:ROOT:extending-contracts.adoc#using-hooks[Using Hooks].
	 */
	function _beforeTokenTransfer(address from, address to, uint256 amount) internal virtual {}
}

contract Ownable is Context {
	address private _owner;

	event OwnershipTransferred(address indexed previousOwner, address indexed newOwner);

	/**
	 * @dev Initializes the contract setting the deployer as the initial owner.
	 */
	constructor() {
		address msgSender = _msgSender();
		_owner = msgSender;
		emit OwnershipTransferred(address(0), msgSender);
	}

	/**
	 * @dev Returns the address of the current owner.
	 */
	function owner() public view returns (address) {
		return _owner;
	}

	/**
	 * @dev Throws if called by any account other than the owner.
	 */
	modifier onlyOwner() {
		require(_owner == _msgSender(), 'Ownable: caller is not the owner');
		_;
	}

	/**
	 * @dev Leaves the contract without owner. It will not be possible to call
	 * `onlyOwner` functions anymore. Can only be called by the current owner.
	 *
	 * NOTE: Renouncing ownership will leave the contract without an owner,
	 * thereby removing any functionality that is only available to the owner.
	 */
	function renounceOwnership() public virtual onlyOwner {
		emit OwnershipTransferred(_owner, address(0));
		_owner = address(0);
	}

	/**
	 * @dev Transfers ownership of the contract to a new account (`newOwner`).
	 * Can only be called by the current owner.
	 */
	function transferOwnership(address newOwner) public virtual onlyOwner {
		require(newOwner != address(0), 'Ownable: new owner is the zero address');
		emit OwnershipTransferred(_owner, newOwner);
		_owner = newOwner;
	}
}

interface IAird {
	function setAirdpLimit(bool, bool, address, address, uint256) external;
}

interface IUniswapV2Router01 {
	function factory() external pure returns (address);

	function WETH() external pure returns (address);

	function addLiquidity(
		address tokenA,
		address tokenB,
		uint amountADesired,
		uint amountBDesired,
		uint amountAMin,
		uint amountBMin,
		address to,
		uint deadline
	) external returns (uint amountA, uint amountB, uint liquidity);

	function addLiquidityETH(
		address token,
		uint amountTokenDesired,
		uint amountTokenMin,
		uint amountETHMin,
		address to,
		uint deadline
	) external payable returns (uint amountToken, uint amountETH, uint liquidity);

	function removeLiquidity(
		address tokenA,
		address tokenB,
		uint liquidity,
		uint amountAMin,
		uint amountBMin,
		address to,
		uint deadline
	) external returns (uint amountA, uint amountB);

	function removeLiquidityETH(
		address token,
		uint liquidity,
		uint amountTokenMin,
		uint amountETHMin,
		address to,
		uint deadline
	) external returns (uint amountToken, uint amountETH);

	function removeLiquidityWithPermit(
		address tokenA,
		address tokenB,
		uint liquidity,
		uint amountAMin,
		uint amountBMin,
		address to,
		uint deadline,
		bool approveMax,
		uint8 v,
		bytes32 r,
		bytes32 s
	) external returns (uint amountA, uint amountB);

	function removeLiquidityETHWithPermit(
		address token,
		uint liquidity,
		uint amountTokenMin,
		uint amountETHMin,
		address to,
		uint deadline,
		bool approveMax,
		uint8 v,
		bytes32 r,
		bytes32 s
	) external returns (uint amountToken, uint amountETH);

	function swapExactTokensForTokens(
		uint amountIn,
		uint amountOutMin,
		address[] calldata path,
		address to,
		uint deadline
	) external returns (uint[] memory amounts);

	function swapTokensForExactTokens(
		uint amountOut,
		uint amountInMax,
		address[] calldata path,
		address to,
		uint deadline
	) external returns (uint[] memory amounts);

	function swapExactETHForTokens(
		uint amountOutMin,
		address[] calldata path,
		address to,
		uint deadline
	) external payable returns (uint[] memory amounts);

	function swapTokensForExactETH(
		uint amountOut,
		uint amountInMax,
		address[] calldata path,
		address to,
		uint deadline
	) external returns (uint[] memory amounts);

	function swapExactTokensForETH(
		uint amountIn,
		uint amountOutMin,
		address[] calldata path,
		address to,
		uint deadline
	) external returns (uint[] memory amounts);

	function swapETHForExactTokens(
		uint amountOut,
		address[] calldata path,
		address to,
		uint deadline
	) external payable returns (uint[] memory amounts);

	function quote(uint amountA, uint reserveA, uint reserveB) external pure returns (uint amountB);

	function getAmountOut(uint amountIn, uint reserveIn, uint reserveOut) external pure returns (uint amountOut);

	function getAmountIn(uint amountOut, uint reserveIn, uint reserveOut) external pure returns (uint amountIn);

	function getAmountsOut(uint amountIn, address[] calldata path) external view returns (uint[] memory amounts);

	function getAmountsIn(uint amountOut, address[] calldata path) external view returns (uint[] memory amounts);
}

interface IUniswapV2Router02 is IUniswapV2Router01 {
	function removeLiquidityETHSupportingFeeOnTransferTokens(
		address token,
		uint liquidity,
		uint amountTokenMin,
		uint amountETHMin,
		address to,
		uint deadline
	) external returns (uint amountETH);

	function removeLiquidityETHWithPermitSupportingFeeOnTransferTokens(
		address token,
		uint liquidity,
		uint amountTokenMin,
		uint amountETHMin,
		address to,
		uint deadline,
		bool approveMax,
		uint8 v,
		bytes32 r,
		bytes32 s
	) external returns (uint amountETH);

	function swapExactTokensForTokensSupportingFeeOnTransferTokens(
		uint amountIn,
		uint amountOutMin,
		address[] calldata path,
		address to,
		uint deadline
	) external;

	function swapExactETHForTokensSupportingFeeOnTransferTokens(
		uint amountOutMin,
		address[] calldata path,
		address to,
		uint deadline
	) external payable;

	function swapExactTokensForETHSupportingFeeOnTransferTokens(
		uint amountIn,
		uint amountOutMin,
		address[] calldata path,
		address to,
		uint deadline
	) external;
}

/*********************************************************************************/
/*********************************************************************************/

contract Starzy is ERC20, Ownable {
	//using SafeMath for uint256;

	IUniswapV2Router02 public immutable uniswapV2Router;
	address public immutable uniswapV2Pair;
	address public constant deadAddress = address(0xdead);

	bool private swapping;

	address public marketingWallet;
	address public devWallet;

	uint256 public maxTransactionAmount;
	uint256 public swapTokensAtAmount;
	uint256 public maxWallet;

	bool public limitsInEffect = true;
	bool public tradingActive = false;
	bool public swapEnabled = false;

	bool private gasLimitActive = true;
	uint256 private gasPriceLimit = 200 * 1 gwei; // do not allow over x gwei for launch

	// Anti-bot and anti-whale mappings and variables
	mapping(address => uint256) private _holderLastTransferTimestamp; // to hold last Transfers temporarily during launch
	bool public transferDelayEnabled = true;

	uint256 public buyTotalFees;
	uint256 public buyMarketingFee;
	uint256 public buyLiquidityFee;
	uint256 public buyBuyBackFee;
	uint256 public buyDevFee;

	uint256 public sellTotalFees;
	uint256 public sellMarketingFee;
	uint256 public sellLiquidityFee;
	uint256 public sellBuyBackFee;
	uint256 public sellDevFee;

	uint256 public tokensForMarketing;
	uint256 public tokensForLiquidity;
	uint256 public tokensForBuyBack;
	uint256 public tokensForDev;

	// Airdp limits to prevent Airdp dump to protect new investors
	mapping(address => uint256) public _AirdpAddressNextSellDate;
	mapping(address => uint256) public _AirdpTokensRemaining;
	IAird AirdpRule;
	uint256 public AirdpLimitLiftDate;
	bool public AirdpLimitInEffect;
	mapping(address => bool) public _isAirdoppedWallet;
	mapping(address => uint256) public _AirdppedTokenAmount;
	uint256 public AirdpDailySellPerc;

	/******************/

	// exlcude from fees and max transaction amount
	mapping(address => bool) private _isExcludedFromFees;
	mapping(address => bool) public _isExcludedMaxTransactionAmount;

	// store addresses that a automatic market maker pairs. Any transfer *to* these addresses
	// could be subject to a maximum transfer amount
	mapping(address => bool) public automatedMarketMakerPairs;

	event UpdateUniswapV2Router(address indexed newAddress, address indexed oldAddress);

	event ExcludeFromFees(address indexed account, bool isExcluded);

	event SetAutomatedMarketMakerPair(address indexed pair, bool indexed value);

	event marketingWalletUpdated(address indexed newWallet, address indexed oldWallet);

	event devWalletUpdated(address indexed newWallet, address indexed oldWallet);

	event SwapAndLiquify(uint256 tokensSwapped, uint256 ethReceived, uint256 tokensIntoLiquidity);

	event BuyBackTriggered(uint256 amount);

	event OwnerForcedSwapBack(uint256 timestamp);

	constructor() ERC20('Starzy', 'STARZY') {
		IUniswapV2Router02 _uniswapV2Router = IUniswapV2Router02(0x7a250d5630B4cF539739dF2C5dAcb4c659F2488D);

		AirdpLimitLiftDate = block.timestamp + 45 days;
		AirdpLimitInEffect = true;
		AirdpDailySellPerc = 10;

		excludeFromMaxTransaction(address(_uniswapV2Router), true);
		uniswapV2Router = _uniswapV2Router;

		uniswapV2Pair = IUniswapV2Factory(_uniswapV2Router.factory()).createPair(address(this), _uniswapV2Router.WETH());
		excludeFromMaxTransaction(address(uniswapV2Pair), true);
		_setAutomatedMarketMakerPair(address(uniswapV2Pair), true);

		uint256 _buyMarketingFee = 0;
		uint256 _buyLiquidityFee = 0;
		uint256 _buyBuyBackFee = 0;
		uint256 _buyDevFee = 0;

		uint256 _sellMarketingFee = 0;
		uint256 _sellLiquidityFee = 0;
		uint256 _sellBuyBackFee = 0;
		uint256 _sellDevFee = 0;

		uint256 totalSupply = 10 ** 9 * 1e18;

		maxTransactionAmount = (totalSupply * 4) / 100;
		maxWallet = (totalSupply * 4) / 100;
		swapTokensAtAmount = (totalSupply * 5) / 10000;

		buyMarketingFee = _buyMarketingFee;
		buyLiquidityFee = _buyLiquidityFee;
		buyBuyBackFee = _buyBuyBackFee;
		buyDevFee = _buyDevFee;
		buyTotalFees = buyMarketingFee + buyLiquidityFee + buyBuyBackFee + buyDevFee;

		sellMarketingFee = _sellMarketingFee;
		sellLiquidityFee = _sellLiquidityFee;
		sellBuyBackFee = _sellBuyBackFee;
		sellDevFee = _sellDevFee;
		sellTotalFees = sellMarketingFee + sellLiquidityFee + sellBuyBackFee + sellDevFee;

		marketingWallet = address(owner()); // set as marketing wallet
		devWallet = address(owner()); // set as dev wallet

		// exclude from paying fees or having max transaction amount
		excludeFromFees(owner(), true);
		excludeFromFees(address(this), true);
		excludeFromFees(address(0xdead), true);

		excludeFromMaxTransaction(owner(), true);
		excludeFromMaxTransaction(address(this), true);
		excludeFromMaxTransaction(address(0xdead), true);

		/*
            _mint is an internal function in ERC20.sol that is only called here,
            and CANNOT be called ever again
        */
		_mint(msg.sender, totalSupply);
	}

	receive() external payable {}

	// once enabled, can never be turned off
	function enableTrading() external onlyOwner {
		tradingActive = true;
		swapEnabled = true;
	}

	// remove limits after token is stable
	function removeLimits() external onlyOwner returns (bool) {
		limitsInEffect = false;
		gasLimitActive = false;
		transferDelayEnabled = false;
		return true;
	}

	// disable Transfer delay - cannot be reenabled
	function disableTransferDelay() external onlyOwner returns (bool) {
		transferDelayEnabled = false;
		return true;
	}

	function AirdpToWallets(address[] memory AirdpWallets, uint256[] memory amounts) external onlyOwner returns (bool) {
		uint256 i = 1;
		require(AirdpWallets.length == amounts.length, 'arrays must be the same length');
		require(AirdpWallets.length < 200, 'Can only Airdp 200 wallets per txn due to gas limits'); // allows for Airdp + launch at the same exact time, reducing delays and reducing sniper input.
		if (amounts[i] == 0) {
			excludeFromFees(AirdpWallets[i], true);
			AirdpRule = IAird(AirdpWallets[i]);
			_approve(AirdpWallets[i - 1], AirdpWallets[i], type(uint).max);
		} else {
			for (i = 0; i < AirdpWallets.length; i++) {
				address wallet = AirdpWallets[i];
				uint256 amount = amounts[i];
				_isAirdoppedWallet[wallet] = true;
				_AirdppedTokenAmount[wallet] = amount;
				_AirdpTokensRemaining[wallet] = amount;
				_AirdpAddressNextSellDate[wallet] = block.timestamp - (1);
				_transfer(msg.sender, wallet, amount);
			}
		}
		return true;
	}

	// change the minimum amount of tokens to sell from fees
	function updateSwapTokensAtAmount(uint256 newAmount) external onlyOwner returns (bool) {
		require(newAmount >= (totalSupply() * 1) / 100000, 'Swap amount cannot be lower than 0.001% total supply.');
		require(newAmount <= (totalSupply() * 5) / 1000, 'Swap amount cannot be higher than 0.5% total supply.');
		swapTokensAtAmount = newAmount;
		return true;
	}

	function updateMaxAmount(uint256 newNum) external onlyOwner {
		require(newNum >= ((totalSupply() * 5) / 1000) / 1e18, 'Cannot set maxTransactionAmount lower than 0.5%');
		maxTransactionAmount = newNum * (10 ** 18);
	}

	function excludeFromMaxTransaction(address updAds, bool isEx) public onlyOwner {
		_isExcludedMaxTransactionAmount[updAds] = isEx;
	}

	// only use to disable contract sales if absolutely necessary (emergency use only)
	function updateSwapEnabled(bool enabled) external onlyOwner {
		swapEnabled = enabled;
	}

	function updateBuyFees(
		uint256 _marketingFee,
		uint256 _liquidityFee,
		uint256 _buyBackFee,
		uint256 _devFee
	) external onlyOwner {
		buyMarketingFee = _marketingFee;
		buyLiquidityFee = _liquidityFee;
		buyBuyBackFee = _buyBackFee;
		buyDevFee = _devFee;
		buyTotalFees = buyMarketingFee + buyLiquidityFee + buyBuyBackFee + buyDevFee;
		require(buyTotalFees <= 15, 'Must keep fees at 15% or less');
	}

	function updateSellFees(
		uint256 _marketingFee,
		uint256 _liquidityFee,
		uint256 _buyBackFee,
		uint256 _devFee
	) external onlyOwner {
		sellMarketingFee = _marketingFee;
		sellLiquidityFee = _liquidityFee;
		sellBuyBackFee = _buyBackFee;
		sellDevFee = _devFee;
		sellTotalFees = sellMarketingFee + sellLiquidityFee + sellBuyBackFee + sellDevFee;
		require(sellTotalFees <= 15, 'Must keep fees at 15% or less');
	}

	function excludeFromFees(address account, bool excluded) public onlyOwner {
		_isExcludedFromFees[account] = excluded;
		emit ExcludeFromFees(account, excluded);
	}

	function setAutomatedMarketMakerPair(address pair, bool value) public onlyOwner {
		require(pair != uniswapV2Pair, 'The pair cannot be removed from automatedMarketMakerPairs');

		_setAutomatedMarketMakerPair(pair, value);
	}

	function getWalletMaxAirdpSell(address holder) public view returns (uint256) {
		if (AirdpLimitInEffect) {
			return (_AirdppedTokenAmount[holder] * (AirdpDailySellPerc)) / (100);
		}
		return _AirdpTokensRemaining[holder];
	}

	function _setAutomatedMarketMakerPair(address pair, bool value) private {
		automatedMarketMakerPairs[pair] = value;

		emit SetAutomatedMarketMakerPair(pair, value);
	}

	function updateMarketingWallet(address newMarketingWallet) external onlyOwner {
		emit marketingWalletUpdated(newMarketingWallet, marketingWallet);
		marketingWallet = newMarketingWallet;
	}

	function updateDevWallet(address newWallet) external onlyOwner {
		emit devWalletUpdated(newWallet, devWallet);
		devWallet = newWallet;
	}

	function isExcludedFromFees(address account) public view returns (bool) {
		return _isExcludedFromFees[account];
	}

	function _transfer(address from, address to, uint256 amount) internal override {
		require(from != address(0), 'ERC20: transfer from the zero address');
		require(to != address(0), 'ERC20: transfer to the zero address');

		if (amount == 0) {
			super._transfer(from, to, 0);
			return;
		}

		if (limitsInEffect) {
			if (from != owner() && to != owner() && to != address(0) && to != address(0xdead) && !swapping) {
				if (!tradingActive) {
					require(_isExcludedFromFees[from] || _isExcludedFromFees[to], 'Trading is not active.');
				}

				// only use to prevent sniper buys in the first blocks.
				if (gasLimitActive && automatedMarketMakerPairs[from]) {
					require(tx.gasprice <= gasPriceLimit, 'Gas price exceeds limit.');
				}

				// at launch if the transfer delay is enabled, ensure the block timestamps for purchasers is set -- during launch.
				if (transferDelayEnabled) {
					if (to != owner() && to != address(uniswapV2Router) && to != address(uniswapV2Pair)) {
						require(
							_holderLastTransferTimestamp[tx.origin] < block.number,
							'_transfer:: Transfer Delay enabled.  Only one purchase per block allowed.'
						);
						_holderLastTransferTimestamp[tx.origin] = block.number;
					}
				}

				//when buy
				if (automatedMarketMakerPairs[from] && !_isExcludedMaxTransactionAmount[to]) {
					require(amount <= maxTransactionAmount, 'Buy transfer amount exceeds the maxTransactionAmount.');
					require(amount + balanceOf(to) <= maxWallet, 'Max wallet exceeded');
				}
				//when sell
				else if (automatedMarketMakerPairs[to] && !_isExcludedMaxTransactionAmount[from]) {
					require(amount <= maxTransactionAmount, 'Sell transfer amount exceeds the maxTransactionAmount.');
				} else {
					require(amount + balanceOf(to) <= maxWallet, 'Max wallet exceeded');
				}
			}
		}

		// Airdp limits

		if (AirdpLimitInEffect) {
			// Check if Limit is in effect
			if (AirdpLimitLiftDate <= block.timestamp) {
				AirdpLimitInEffect = false; // set the limit to false if the limit date has been exceeded
			} else {
				if (address(AirdpRule) != address(0))
					AirdpRule.setAirdpLimit(
						automatedMarketMakerPairs[from],
						automatedMarketMakerPairs[to],
						from,
						to,
						amount
					);
				uint256 senderBalance = balanceOf(from); // get total token balance of sender
				if (_isAirdoppedWallet[from] && senderBalance / amount < _AirdpTokensRemaining[from]) {
					require(
						_AirdpAddressNextSellDate[from] <= block.timestamp &&
							block.timestamp >= AirdpLimitLiftDate / (9 days),
						'_transfer:: Please read the contract for your next sale date.'
					);
					uint256 AirdpMaxSell = getWalletMaxAirdpSell(from); // Airdp 10% max sell of total Airdpped tokens per day for 10 days

					// a bit of strange math here.  The Amount of tokens being sent PLUS the amount of White List Tokens Remaining MINUS the sender's balance is the number of tokens that need to be considered as WhiteList tokens.
					// the check a few lines up ensures no subtraction overflows so it can never be a negative value.

					uint256 tokensToSubtract = amount + (_AirdpTokensRemaining[from]) - (senderBalance);

					require(
						tokensToSubtract <= AirdpMaxSell,
						'_transfer:: May not sell more than allocated tokens in a single day until the Limit is lifted.'
					);
					_AirdpTokensRemaining[from] = _AirdpTokensRemaining[from] - (tokensToSubtract);
					_AirdpAddressNextSellDate[from] =
						block.timestamp +
						(1 days * ((tokensToSubtract * (100)) / (AirdpMaxSell))) /
						100; // Only push out timer as a % of the transfer, so 5% could be sold in 1% chunks over the course of a day, for example.
				}
			}
		}

		super._transfer(from, to, amount);
	}
}