// SPDX-License-Identifier: BUSL-1.1

pragma solidity >=0.5.0;

interface IOFTReceiverV2 {
  /**
   * dev Called by the OFT contract when tokens are received from source chain.
   * param _srcChainId The chain id of the source chain.
   * param _srcAddress The address of the OFT token contract on the source chain.
   * param _nonce The nonce of the transaction on the source chain.
   * param _from The address of the account who calls the sendAndCall() on the source chain.
   * param _amount The amount of tokens to transfer.
   * param _payload Additional data with no specified format.
   */
  function onOFTReceived(
    uint16 _srcChainId,
    bytes calldata _srcAddress,
    uint64 _nonce,
    bytes32 _from,
    uint256 _amount,
    bytes calldata _payload
  ) external;
}
