// SPDX-License-Identifier: MIT
// Copyright (c) 2021 the ethier authors (github.com/divergencetech/ethier)
pragma solidity >=0.8.0 <0.9.0;

import "openzeppelin/contracts/access/Ownable.sol";
import "openzeppelin/contracts/security/Pausable.sol";

/// notice A Pausable contract that can only be toggled by the Owner.
contract OwnerPausable is Ownable, Pausable {
    /// notice Pauses the contract.
    function pause() public onlyOwner {
        Pausable._pause();
    }

    /// notice Unpauses the contract.
    function unpause() public onlyOwner {
        Pausable._unpause();
    }
}
