// SPDX-License-Identifier: MIT

pragma solidity ^0.8.0;

import "openzeppelin/contracts-upgradeable/access/OwnableUpgradeable.sol";
import "openzeppelin/contracts-upgradeable/proxy/utils/Initializable.sol";
import "openzeppelin/contracts-upgradeable/token/ERC1155/IERC1155Upgradeable.sol";
import "openzeppelin/contracts-upgradeable/token/ERC20/IERC20Upgradeable.sol";
import "openzeppelin/contracts-upgradeable/token/ERC721/IERC721ReceiverUpgradeable.sol";
import "openzeppelin/contracts-upgradeable/token/ERC721/IERC721Upgradeable.sol";
import "openzeppelin/contracts-upgradeable/utils/AddressUpgradeable.sol";
import "openzeppelin/contracts-upgradeable/utils/ContextUpgradeable.sol";
import "openzeppelin/contracts-upgradeable/utils/introspection/IERC165Upgradeable.sol";
import "openzeppelin/contracts-upgradeable/utils/structs/EnumerableSetUpgradeable.sol";
import "openzeppelin/contracts/interfaces/draft-IERC1822.sol";
import "openzeppelin/contracts/proxy/ERC1967/ERC1967Upgrade.sol";
import "openzeppelin/contracts/proxy/Proxy.sol";
import "openzeppelin/contracts/proxy/beacon/BeaconProxy.sol";
import "openzeppelin/contracts/proxy/beacon/IBeacon.sol";
import "openzeppelin/contracts/token/ERC20/ERC20.sol";
import "openzeppelin/contracts/token/ERC20/IERC20.sol";
import "openzeppelin/contracts/token/ERC20/extensions/IERC20Metadata.sol";
import "openzeppelin/contracts/utils/Address.sol";
import "openzeppelin/contracts/utils/Context.sol";
import "openzeppelin/contracts/utils/StorageSlot.sol";
import "openzeppelin/contracts/utils/math/Math.sol";
import "openzeppelin/contracts/utils/math/SafeCast.sol";
import "openzeppelin/contracts/utils/math/SafeMath.sol";
import "openzeppelin/contracts/utils/structs/EnumerableSet.sol";
import "contracts/CollateralManager.sol";
import "contracts/EAS/TellerAS.sol";
import "contracts/TellerV2Storage.sol";
import "contracts/Types.sol";
import "contracts/interfaces/IASRegistry.sol";
import "contracts/interfaces/IASResolver.sol";
import "contracts/interfaces/ICollateralManager.sol";
import "contracts/interfaces/IEAS.sol";
import "contracts/interfaces/IEASEIP712Verifier.sol";
import "contracts/interfaces/ILenderManager.sol";
import "contracts/interfaces/IMarketRegistry.sol";
import "contracts/interfaces/IReputationManager.sol";
import "contracts/interfaces/ITellerV2.sol";
import "contracts/interfaces/escrow/ICollateralEscrowV1.sol";
import "contracts/libraries/NumbersLib.sol";
import "contracts/libraries/V2Calculations.sol";
import "contracts/libraries/WadRayMath.sol";
