// SPDX-License-Identifier: GPL-3.0

pragma solidity ^0.8.7;

/// title IAccessControl
/// author Forked from OpenZeppelin
/// notice Interface for `AccessControl` contracts
interface IAccessControl {
    function hasRole(bytes32 role, address account) external view returns (bool);

    function getRoleAdmin(bytes32 role) external view returns (bytes32);

    function grantRole(bytes32 role, address account) external;

    function revokeRole(bytes32 role, address account) external;

    function renounceRole(bytes32 role, address account) external;
}
