// SPDX-License-Identifier: MIT

pragma solidity ^0.8.0;

import "openzeppelin/contracts/access/AccessControl.sol";
import "openzeppelin/contracts/access/AccessControlEnumerable.sol";
import "openzeppelin/contracts/access/IAccessControl.sol";
import "openzeppelin/contracts/access/IAccessControlEnumerable.sol";
import "openzeppelin/contracts/token/ERC1155/IERC1155.sol";
import "openzeppelin/contracts/token/ERC20/IERC20.sol";
import "openzeppelin/contracts/token/ERC20/extensions/draft-IERC20Permit.sol";
import "openzeppelin/contracts/token/ERC20/utils/SafeERC20.sol";
import "openzeppelin/contracts/token/ERC721/IERC721.sol";
import "openzeppelin/contracts/token/ERC721/IERC721Receiver.sol";
import "openzeppelin/contracts/utils/Address.sol";
import "openzeppelin/contracts/utils/Context.sol";
import "openzeppelin/contracts/utils/Strings.sol";
import "openzeppelin/contracts/utils/introspection/ERC165.sol";
import "openzeppelin/contracts/utils/introspection/IERC165.sol";
import "openzeppelin/contracts/utils/structs/EnumerableSet.sol";
import "uniswap/v2-core/contracts/interfaces/IUniswapV2Pair.sol";
import "uniswap/v2-periphery/contracts/interfaces/IUniswapV2Router01.sol";
import "contracts/common/interfaces/INonfungiblePositionManager.sol";
import "contracts/common/interfaces/IUniswapPair.sol";
import "contracts/locker/interfaces/IDepositHandler.sol";
import "contracts/locker/interfaces/ILPTokenProcessorV2.sol";
import "contracts/locker/interfaces/IPaymentModule.sol";
import "contracts/locker/interfaces/IPricingModule.sol";
import "contracts/locker/payment/PaymentModuleV1.sol";
import "hardhat/console.sol";
