// SPDX-License-Identifier: GPL-3.0

pragma solidity ^0.8.17;

/// title ITreasury
/// author Angle Core Team
/// notice Interface for the `Treasury` contract
/// dev This interface only contains functions of the `Treasury` which are called by other contracts
/// of this module
interface ITreasury {
    /// notice Checks whether a given address has well been initialized in this contract
    /// as a `VaultManager``
    /// param _vaultManager Address to check
    /// return Whether the address has been initialized or not
    function isVaultManager(address _vaultManager) external view returns (bool);
}
