/**
 *Submitted for verification at Etherscan.io on 2023-05-13
*/

/**
 *Submitted for verification at Etherscan.io on 2022-11-11
*/

/**
 * This ICO Solution was made by ZiLab Technologies.
 * Web: www.zilab.co
 * Telegram: @zilab_technologies
 */

 // Sources flattened with hardhat v2.8.0 https://hardhat.org

 // File @openzeppelin/contracts/utils/math/SafeMath.sol@v4.4.2

 // OpenZeppelin Contracts v4.4.1 (utils/math/SafeMath.sol)

 pragma solidity ^0.8.0;

 // CAUTION
 // This version of SafeMath should only be used with Solidity 0.8 or later,
 // because it relies on the compiler's built in overflow checks.

 /**
  * @dev Wrappers over Solidity's arithmetic operations.
  *
  * NOTE: `SafeMath` is generally not needed starting with Solidity 0.8, since the compiler
  * now has built in overflow checking.
  */
 library SafeMath {
     /**
      * @dev Returns the addition of two unsigned integers, with an overflow flag.
      *
      * _Available since v3.4._
      */
     function tryAdd(uint256 a, uint256 b) internal pure returns (bool, uint256) {
         unchecked {
             uint256 c = a + b;
             if (c < a) return (false, 0);
             return (true, c);
         }
     }

     /**
      * @dev Returns the substraction of two unsigned integers, with an overflow flag.
      *
      * _Available since v3.4._
      */
     function trySub(uint256 a, uint256 b) internal pure returns (bool, uint256) {
         unchecked {
             if (b > a) return (false, 0);
             return (true, a - b);
         }
     }

     /**
      * @dev Returns the multiplication of two unsigned integers, with an overflow flag.
      *
      * _Available since v3.4._
      */
     function tryMul(uint256 a, uint256 b) internal pure returns (bool, uint256) {
         unchecked {
             // Gas optimization: this is cheaper than requiring 'a' not being zero, but the
             // benefit is lost if 'b' is also tested.
             // See: https://github.com/OpenZeppelin/openzeppelin-contracts/pull/522
             if (a == 0) return (true, 0);
             uint256 c = a * b;
             if (c / a != b) return (false, 0);
             return (true, c);
         }
     }

     /**
      * @dev Returns the division of two unsigned integers, with a division by zero flag.
      *
      * _Available since v3.4._
      */
     function tryDiv(uint256 a, uint256 b) internal pure returns (bool, uint256) {
         unchecked {
             if (b == 0) return (false, 0);
             return (true, a / b);
         }
     }

     /**
      * @dev Returns the remainder of dividing two unsigned integers, with a division by zero flag.
      *
      * _Available since v3.4._
      */
     function tryMod(uint256 a, uint256 b) internal pure returns (bool, uint256) {
         unchecked {
             if (b == 0) return (false, 0);
             return (true, a % b);
         }
     }

     /**
      * @dev Returns the addition of two unsigned integers, reverting on
      * overflow.
      *
      * Counterpart to Solidity's `+` operator.
      *
      * Requirements:
      *
      * - Addition cannot overflow.
      */
     function add(uint256 a, uint256 b) internal pure returns (uint256) {
         return a + b;
     }

     /**
      * @dev Returns the subtraction of two unsigned integers, reverting on
      * overflow (when the result is negative).
      *
      * Counterpart to Solidity's `-` operator.
      *
      * Requirements:
      *
      * - Subtraction cannot overflow.
      */
     function sub(uint256 a, uint256 b) internal pure returns (uint256) {
         return a - b;
     }

     /**
      * @dev Returns the multiplication of two unsigned integers, reverting on
      * overflow.
      *
      * Counterpart to Solidity's `*` operator.
      *
      * Requirements:
      *
      * - Multiplication cannot overflow.
      */
     function mul(uint256 a, uint256 b) internal pure returns (uint256) {
         return a * b;
     }

     /**
      * @dev Returns the integer division of two unsigned integers, reverting on
      * division by zero. The result is rounded towards zero.
      *
      * Counterpart to Solidity's `/` operator.
      *
      * Requirements:
      *
      * - The divisor cannot be zero.
      */
     function div(uint256 a, uint256 b) internal pure returns (uint256) {
         return a / b;
     }

     /**
      * @dev Returns the remainder of dividing two unsigned integers. (unsigned integer modulo),
      * reverting when dividing by zero.
      *
      * Counterpart to Solidity's `%` operator. This function uses a `revert`
      * opcode (which leaves remaining gas untouched) while Solidity uses an
      * invalid opcode to revert (consuming all remaining gas).
      *
      * Requirements:
      *
      * - The divisor cannot be zero.
      */
     function mod(uint256 a, uint256 b) internal pure returns (uint256) {
         return a % b;
     }

     /**
      * @dev Returns the subtraction of two unsigned integers, reverting with custom message on
      * overflow (when the result is negative).
      *
      * CAUTION: This function is deprecated because it requires allocating memory for the error
      * message unnecessarily. For custom revert reasons use {trySub}.
      *
      * Counterpart to Solidity's `-` operator.
      *
      * Requirements:
      *
      * - Subtraction cannot overflow.
      */
     function sub(
         uint256 a,
         uint256 b,
         string memory errorMessage
     ) internal pure returns (uint256) {
         unchecked {
             require(b <= a, errorMessage);
             return a - b;
         }
     }

     /**
      * @dev Returns the integer division of two unsigned integers, reverting with custom message on
      * division by zero. The result is rounded towards zero.
      *
      * Counterpart to Solidity's `/` operator. Note: this function uses a
      * `revert` opcode (which leaves remaining gas untouched) while Solidity
      * uses an invalid opcode to revert (consuming all remaining gas).
      *
      * Requirements:
      *
      * - The divisor cannot be zero.
      */
     function div(
         uint256 a,
         uint256 b,
         string memory errorMessage
     ) internal pure returns (uint256) {
         unchecked {
             require(b > 0, errorMessage);
             return a / b;
         }
     }

     /**
      * @dev Returns the remainder of dividing two unsigned integers. (unsigned integer modulo),
      * reverting with custom message when dividing by zero.
      *
      * CAUTION: This function is deprecated because it requires allocating memory for the error
      * message unnecessarily. For custom revert reasons use {tryMod}.
      *
      * Counterpart to Solidity's `%` operator. This function uses a `revert`
      * opcode (which leaves remaining gas untouched) while Solidity uses an
      * invalid opcode to revert (consuming all remaining gas).
      *
      * Requirements:
      *
      * - The divisor cannot be zero.
      */
     function mod(
         uint256 a,
         uint256 b,
         string memory errorMessage
     ) internal pure returns (uint256) {
         unchecked {
             require(b > 0, errorMessage);
             return a % b;
         }
     }
 }


 // File @openzeppelin/contracts/token/ERC20/IERC20.sol@v4.4.2

 // OpenZeppelin Contracts v4.4.1 (token/ERC20/IERC20.sol)

 //pragma solidity ^0.8.0;

 /**
  * @dev Interface of the ERC20 standard as defined in the EIP.
  */
 interface IERC20 {
     /**
      * @dev Returns the amount of tokens in existence.
      */
     function totalSupply() external view returns (uint256);

     /**
      * @dev Returns the amount of tokens owned by `account`.
      */
     function balanceOf(address account) external view returns (uint256);

     /**
      * @dev Moves `amount` tokens from the caller's account to `recipient`.
      *
      * Returns a boolean value indicating whether the operation succeeded.
      *
      * Emits a {Transfer} event.
      */
     function transfer(address recipient, uint256 amount) external returns (bool);

     /**
      * @dev Returns the remaining number of tokens that `spender` will be
      * allowed to spend on behalf of `owner` through {transferFrom}. This is
      * zero by default.
      *
      * This value changes when {approve} or {transferFrom} are called.
      */
     function allowance(address owner, address spender) external view returns (uint256);

     /**
      * @dev Sets `amount` as the allowance of `spender` over the caller's tokens.
      *
      * Returns a boolean value indicating whether the operation succeeded.
      *
      * IMPORTANT: Beware that changing an allowance with this method brings the risk
      * that someone may use both the old and the new allowance by unfortunate
      * transaction ordering. One possible solution to mitigate this race
      * condition is to first reduce the spender's allowance to 0 and set the
      * desired value afterwards:
      * https://github.com/ethereum/EIPs/issues/20#issuecomment-263524729
      *
      * Emits an {Approval} event.
      */
     function approve(address spender, uint256 amount) external returns (bool);

     /**
      * @dev Moves `amount` tokens from `sender` to `recipient` using the
      * allowance mechanism. `amount` is then deducted from the caller's
      * allowance.
      *
      * Returns a boolean value indicating whether the operation succeeded.
      *
      * Emits a {Transfer} event.
      */
     function transferFrom(
         address sender,
         address recipient,
         uint256 amount
     ) external returns (bool);

     /**
      * @dev Emitted when `value` tokens are moved from one account (`from`) to
      * another (`to`).
      *
      * Note that `value` may be zero.
      */
     event Transfer(address indexed from, address indexed to, uint256 value);

     /**
      * @dev Emitted when the allowance of a `spender` for an `owner` is set by
      * a call to {approve}. `value` is the new allowance.
      */
     event Approval(address indexed owner, address indexed spender, uint256 value);
 }


 // File @openzeppelin/contracts/utils/Context.sol@v4.4.2

 // OpenZeppelin Contracts v4.4.1 (utils/Context.sol)

 //pragma solidity ^0.8.0;

 /**
  * @dev Provides information about the current execution context, including the
  * sender of the transaction and its data. While these are generally available
  * via msg.sender and msg.data, they should not be accessed in such a direct
  * manner, since when dealing with meta-transactions the account sending and
  * paying for execution may not be the actual sender (as far as an application
  * is concerned).
  *
  * This contract is only required for intermediate, library-like contracts.
  */
 abstract contract Context {
     function _msgSender() internal view virtual returns (address) {
         return msg.sender;
     }

     function _msgData() internal view virtual returns (bytes calldata) {
         return msg.data;
     }
 }


 // File @openzeppelin/contracts/access/Ownable.sol@v4.4.2

 // OpenZeppelin Contracts v4.4.1 (access/Ownable.sol)

 //pragma solidity ^0.8.0;

 /**
  * @dev Contract module which provides a basic access control mechanism, where
  * there is an account (an owner) that can be granted exclusive access to
  * specific functions.
  *
  * By default, the owner account will be the one that deploys the contract. This
  * can later be changed with {transferOwnership}.
  *
  * This module is used through inheritance. It will make available the modifier
  * `onlyOwner`, which can be applied to your functions to restrict their use to
  * the owner.
  */
 abstract contract Ownable is Context {
     address private _owner;

     event OwnershipTransferred(address indexed previousOwner, address indexed newOwner);

     /**
      * @dev Initializes the contract setting the deployer as the initial owner.
      */
     constructor() {
         _transferOwnership(_msgSender());
     }

     /**
      * @dev Returns the address of the current owner.
      */
     function owner() public view virtual returns (address) {
         return _owner;
     }

     /**
      * @dev Throws if called by any account other than the owner.
      */
     modifier onlyOwner() {
         require(owner() == _msgSender(), "Ownable: caller is not the owner");
         _;
     }

     /**
      * @dev Leaves the contract without owner. It will not be possible to call
      * `onlyOwner` functions anymore. Can only be called by the current owner.
      *
      * NOTE: Renouncing ownership will leave the contract without an owner,
      * thereby removing any functionality that is only available to the owner.
      */
     function renounceOwnership() public virtual onlyOwner {
         _transferOwnership(address(0));
     }

     /**
      * @dev Transfers ownership of the contract to a new account (`newOwner`).
      * Can only be called by the current owner.
      */
     function transferOwnership(address newOwner) public virtual onlyOwner {
         require(newOwner != address(0), "Ownable: new owner is the zero address");
         _transferOwnership(newOwner);
     }

     /**
      * @dev Transfers ownership of the contract to a new account (`newOwner`).
      * Internal function without access restriction.
      */
     function _transferOwnership(address newOwner) internal virtual {
         address oldOwner = _owner;
         _owner = newOwner;
         emit OwnershipTransferred(oldOwner, newOwner);
     }
 }


 // File contracts/OwnerWithdrawable.sol

 //pragma solidity ^0.8.0;



 contract OwnerWithdrawable is Ownable {
     using SafeMath for uint256;

     receive() external payable {}

     fallback() external payable {}

     function withdraw(address token, uint256 amt) public onlyOwner {
         IERC20(token).transfer(msg.sender, amt);
     }

     function withdrawAll(address token) public onlyOwner {
         uint256 amt = IERC20(token).balanceOf(address(this));
         withdraw(token, amt);
     }

     function withdrawCurrency(uint256 amt) public onlyOwner {
         payable(msg.sender).transfer(amt);
     }

     // function deposit(address token, uint256 amt) public onlyOwner {
     //     uint256 allowance = IERC20(token).allowance(msg.sender, address(this));
     //     require(allowance >= amt, "Check the token allowance");
     //     IERC20(token).transferFrom(owner(), address(this), amt);
     // }
 }


 // File @openzeppelin/contracts/utils/Address.sol@v4.4.2

 // OpenZeppelin Contracts v4.4.1 (utils/Address.sol)

 //pragma solidity ^0.8.0;

 /**
  * @dev Collection of functions related to the address type
  */
 library Address {
     /**
      * @dev Returns true if `account` is a contract.
      *
      * [IMPORTANT]
      * ====
      * It is unsafe to assume that an address for which this function returns
      * false is an externally-owned account (EOA) and not a contract.
      *
      * Among others, `isContract` will return false for the following
      * types of addresses:
      *
      *  - an externally-owned account
      *  - a contract in construction
      *  - an address where a contract will be created
      *  - an address where a contract lived, but was destroyed
      * ====
      */
     function isContract(address account) internal view returns (bool) {
         // This method relies on extcodesize, which returns 0 for contracts in
         // construction, since the code is only stored at the end of the
         // constructor execution.

         uint256 size;
         assembly {
             size := extcodesize(account)
         }
         return size > 0;
     }

     /**
      * @dev Replacement for Solidity's `transfer`: sends `amount` wei to
      * `recipient`, forwarding all available gas and reverting on errors.
      *
      * https://eips.ethereum.org/EIPS/eip-1884[EIP1884] increases the gas cost
      * of certain opcodes, possibly making contracts go over the 2300 gas limit
      * imposed by `transfer`, making them unable to receive funds via
      * `transfer`. {sendValue} removes this limitation.
      *
      * https://diligence.consensys.net/posts/2019/09/stop-using-soliditys-transfer-now/[Learn more].
      *
      * IMPORTANT: because control is transferred to `recipient`, care must be
      * taken to not create reentrancy vulnerabilities. Consider using
      * {ReentrancyGuard} or the
      * https://solidity.readthedocs.io/en/v0.5.11/security-considerations.html#use-the-checks-effects-interactions-pattern[checks-effects-interactions pattern].
      */
     function sendValue(address payable recipient, uint256 amount) internal {
         require(address(this).balance >= amount, "Address: insufficient balance");

         (bool success, ) = recipient.call{value: amount}("");
         require(success, "Address: unable to send value, recipient may have reverted");
     }

     /**
      * @dev Performs a Solidity function call using a low level `call`. A
      * plain `call` is an unsafe replacement for a function call: use this
      * function instead.
      *
      * If `target` reverts with a revert reason, it is bubbled up by this
      * function (like regular Solidity function calls).
      *
      * Returns the raw returned data. To convert to the expected return value,
      * use https://solidity.readthedocs.io/en/latest/units-and-global-variables.html?highlight=abi.decode#abi-encoding-and-decoding-functions[`abi.decode`].
      *
      * Requirements:
      *
      * - `target` must be a contract.
      * - calling `target` with `data` must not revert.
      *
      * _Available since v3.1._
      */
     function functionCall(address target, bytes memory data) internal returns (bytes memory) {
         return functionCall(target, data, "Address: low-level call failed");
     }

     /**
      * @dev Same as {xref-Address-functionCall-address-bytes-}[`functionCall`], but with
      * `errorMessage` as a fallback revert reason when `target` reverts.
      *
      * _Available since v3.1._
      */
     function functionCall(
         address target,
         bytes memory data,
         string memory errorMessage
     ) internal returns (bytes memory) {
         return functionCallWithValue(target, data, 0, errorMessage);
     }

     /**
      * @dev Same as {xref-Address-functionCall-address-bytes-}[`functionCall`],
      * but also transferring `value` wei to `target`.
      *
      * Requirements:
      *
      * - the calling contract must have an ETH balance of at least `value`.
      * - the called Solidity function must be `payable`.
      *
      * _Available since v3.1._
      */
     function functionCallWithValue(
         address target,
         bytes memory data,
         uint256 value
     ) internal returns (bytes memory) {
         return functionCallWithValue(target, data, value, "Address: low-level call with value failed");
     }

     /**
      * @dev Same as {xref-Address-functionCallWithValue-address-bytes-uint256-}[`functionCallWithValue`], but
      * with `errorMessage` as a fallback revert reason when `target` reverts.
      *
      * _Available since v3.1._
      */
     function functionCallWithValue(
         address target,
         bytes memory data,
         uint256 value,
         string memory errorMessage
     ) internal returns (bytes memory) {
         require(address(this).balance >= value, "Address: insufficient balance for call");
         require(isContract(target), "Address: call to non-contract");

         (bool success, bytes memory returndata) = target.call{value: value}(data);
         return verifyCallResult(success, returndata, errorMessage);
     }

     /**
      * @dev Same as {xref-Address-functionCall-address-bytes-}[`functionCall`],
      * but performing a static call.
      *
      * _Available since v3.3._
      */
     function functionStaticCall(address target, bytes memory data) internal view returns (bytes memory) {
         return functionStaticCall(target, data, "Address: low-level static call failed");
     }

     /**
      * @dev Same as {xref-Address-functionCall-address-bytes-string-}[`functionCall`],
      * but performing a static call.
      *
      * _Available since v3.3._
      */
     function functionStaticCall(
         address target,
         bytes memory data,
         string memory errorMessage
     ) internal view returns (bytes memory) {
         require(isContract(target), "Address: static call to non-contract");

         (bool success, bytes memory returndata) = target.staticcall(data);
         return verifyCallResult(success, returndata, errorMessage);
     }

     /**
      * @dev Same as {xref-Address-functionCall-address-bytes-}[`functionCall`],
      * but performing a delegate call.
      *
      * _Available since v3.4._
      */
     function functionDelegateCall(address target, bytes memory data) internal returns (bytes memory) {
         return functionDelegateCall(target, data, "Address: low-level delegate call failed");
     }

     /**
      * @dev Same as {xref-Address-functionCall-address-bytes-string-}[`functionCall`],
      * but performing a delegate call.
      *
      * _Available since v3.4._
      */
     function functionDelegateCall(
         address target,
         bytes memory data,
         string memory errorMessage
     ) internal returns (bytes memory) {
         require(isContract(target), "Address: delegate call to non-contract");

         (bool success, bytes memory returndata) = target.delegatecall(data);
         return verifyCallResult(success, returndata, errorMessage);
     }

     /**
      * @dev Tool to verifies that a low level call was successful, and revert if it wasn't, either by bubbling the
      * revert reason using the provided one.
      *
      * _Available since v4.3._
      */
     function verifyCallResult(
         bool success,
         bytes memory returndata,
         string memory errorMessage
     ) internal pure returns (bytes memory) {
         if (success) {
             return returndata;
         } else {
             // Look for revert reason and bubble it up if present
             if (returndata.length > 0) {
                 // The easiest way to bubble the revert reason is using memory via assembly

                 assembly {
                     let returndata_size := mload(returndata)
                     revert(add(32, returndata), returndata_size)
                 }
             } else {
                 revert(errorMessage);
             }
         }
     }
 }


 // File @openzeppelin/contracts/token/ERC20/utils/SafeERC20.sol@v4.4.2

 // OpenZeppelin Contracts v4.4.1 (token/ERC20/utils/SafeERC20.sol)

 //pragma solidity ^0.8.0;


 /**
  * @title SafeERC20
  * @dev Wrappers around ERC20 operations that throw on failure (when the token
  * contract returns false). Tokens that return no value (and instead revert or
  * throw on failure) are also supported, non-reverting calls are assumed to be
  * successful.
  * To use this library you can add a `using SafeERC20 for IERC20;` statement to your contract,
  * which allows you to call the safe operations as `token.safeTransfer(...)`, etc.
  */
 library SafeERC20 {
     using Address for address;

     function safeTransfer(
         IERC20 token,
         address to,
         uint256 value
     ) internal {
         _callOptionalReturn(token, abi.encodeWithSelector(token.transfer.selector, to, value));
     }

     function safeTransferFrom(
         IERC20 token,
         address from,
         address to,
         uint256 value
     ) internal {
         _callOptionalReturn(token, abi.encodeWithSelector(token.transferFrom.selector, from, to, value));
     }

     /**
      * @dev Deprecated. This function has issues similar to the ones found in
      * {IERC20-approve}, and its usage is discouraged.
      *
      * Whenever possible, use {safeIncreaseAllowance} and
      * {safeDecreaseAllowance} instead.
      */
     function safeApprove(
         IERC20 token,
         address spender,
         uint256 value
     ) internal {
         // safeApprove should only be called when setting an initial allowance,
         // or when resetting it to zero. To increase and decrease it, use
         // 'safeIncreaseAllowance' and 'safeDecreaseAllowance'
         require(
             (value == 0) || (token.allowance(address(this), spender) == 0),
             "SafeERC20: approve from non-zero to non-zero allowance"
         );
         _callOptionalReturn(token, abi.encodeWithSelector(token.approve.selector, spender, value));
     }

     function safeIncreaseAllowance(
         IERC20 token,
         address spender,
         uint256 value
     ) internal {
         uint256 newAllowance = token.allowance(address(this), spender) + value;
         _callOptionalReturn(token, abi.encodeWithSelector(token.approve.selector, spender, newAllowance));
     }

     function safeDecreaseAllowance(
         IERC20 token,
         address spender,
         uint256 value
     ) internal {
         unchecked {
             uint256 oldAllowance = token.allowance(address(this), spender);
             require(oldAllowance >= value, "SafeERC20: decreased allowance below zero");
             uint256 newAllowance = oldAllowance - value;
             _callOptionalReturn(token, abi.encodeWithSelector(token.approve.selector, spender, newAllowance));
         }
     }

     /**
      * @dev Imitates a Solidity high-level call (i.e. a regular function call to a contract), relaxing the requirement
      * on the return value: the return value is optional (but if data is returned, it must not be false).
      * @param token The token targeted by the call.
      * @param data The call data (encoded using abi.encode or one of its variants).
      */
     function _callOptionalReturn(IERC20 token, bytes memory data) private {
         // We need to perform a low level call here, to bypass Solidity's return data size checking mechanism, since
         // we're implementing it ourselves. We use {Address.functionCall} to perform this call, which verifies that
         // the target address contains contract code and also asserts for success in the low-level call.

         bytes memory returndata = address(token).functionCall(data, "SafeERC20: low-level call failed");
         if (returndata.length > 0) {
             // Return data is optional
             require(abi.decode(returndata, (bool)), "SafeERC20: ERC20 operation did not succeed");
         }
     }
 }


 // File @openzeppelin/contracts/token/ERC20/extensions/IERC20Metadata.sol@v4.4.2

 // OpenZeppelin Contracts v4.4.1 (token/ERC20/extensions/IERC20Metadata.sol)

 //pragma solidity ^0.8.0;

 /**
  * @dev Interface for the optional metadata functions from the ERC20 standard.
  *
  * _Available since v4.1._
  */
 interface IERC20Metadata is IERC20 {
     /**
      * @dev Returns the name of the token.
      */
     function name() external view returns (string memory);

     /**
      * @dev Returns the symbol of the token.
      */
     function symbol() external view returns (string memory);

     /**
      * @dev Returns the decimals places of the token.
      */
     function decimals() external view returns (uint8);
 }


 // File contracts/IRouter.sol

 //pragma solidity ^0.8.0;

 interface IUniswapV2Router01 {
     function factory() external pure returns (address);

     function WETH() external pure returns (address);

     function addLiquidity(
         address tokenA,
         address tokenB,
         uint256 amountADesired,
         uint256 amountBDesired,
         uint256 amountAMin,
         uint256 amountBMin,
         address to,
         uint256 deadline
     )
         external
         returns (
             uint256 amountA,
             uint256 amountB,
             uint256 liquidity
         );

     function addLiquidityETH(
         address token,
         uint256 amountTokenDesired,
         uint256 amountTokenMin,
         uint256 amountETHMin,
         address to,
         uint256 deadline
     )
         external
         payable
         returns (
             uint256 amountToken,
             uint256 amountETH,
             uint256 liquidity
         );

     function removeLiquidity(
         address tokenA,
         address tokenB,
         uint256 liquidity,
         uint256 amountAMin,
         uint256 amountBMin,
         address to,
         uint256 deadline
     ) external returns (uint256 amountA, uint256 amountB);

     function removeLiquidityETH(
         address token,
         uint256 liquidity,
         uint256 amountTokenMin,
         uint256 amountETHMin,
         address to,
         uint256 deadline
     ) external returns (uint256 amountToken, uint256 amountETH);

     function removeLiquidityWithPermit(
         address tokenA,
         address tokenB,
         uint256 liquidity,
         uint256 amountAMin,
         uint256 amountBMin,
         address to,
         uint256 deadline,
         bool approveMax,
         uint8 v,
         bytes32 r,
         bytes32 s
     ) external returns (uint256 amountA, uint256 amountB);

     function removeLiquidityETHWithPermit(
         address token,
         uint256 liquidity,
         uint256 amountTokenMin,
         uint256 amountETHMin,
         address to,
         uint256 deadline,
         bool approveMax,
         uint8 v,
         bytes32 r,
         bytes32 s
     ) external returns (uint256 amountToken, uint256 amountETH);

     function swapExactTokensForTokens(
         uint256 amountIn,
         uint256 amountOutMin,
         address[] calldata path,
         address to,
         uint256 deadline
     ) external returns (uint256[] memory amounts);

     function swapTokensForExactTokens(
         uint256 amountOut,
         uint256 amountInMax,
         address[] calldata path,
         address to,
         uint256 deadline
     ) external returns (uint256[] memory amounts);

     function swapExactETHForTokens(
         uint256 amountOutMin,
         address[] calldata path,
         address to,
         uint256 deadline
     ) external payable returns (uint256[] memory amounts);

     function swapTokensForExactETH(
         uint256 amountOut,
         uint256 amountInMax,
         address[] calldata path,
         address to,
         uint256 deadline
     ) external returns (uint256[] memory amounts);

     function swapExactTokensForETH(
         uint256 amountIn,
         uint256 amountOutMin,
         address[] calldata path,
         address to,
         uint256 deadline
     ) external returns (uint256[] memory amounts);

     function swapETHForExactTokens(
         uint256 amountOut,
         address[] calldata path,
         address to,
         uint256 deadline
     ) external payable returns (uint256[] memory amounts);

     function quote(
         uint256 amountA,
         uint256 reserveA,
         uint256 reserveB
     ) external pure returns (uint256 amountB);

     function getAmountOut(
         uint256 amountIn,
         uint256 reserveIn,
         uint256 reserveOut
     ) external pure returns (uint256 amountOut);

     function getAmountIn(
         uint256 amountOut,
         uint256 reserveIn,
         uint256 reserveOut
     ) external pure returns (uint256 amountIn);

     function getAmountsOut(uint256 amountIn, address[] calldata path)
         external
         view
         returns (uint256[] memory amounts);

     function getAmountsIn(uint256 amountOut, address[] calldata path)
         external
         view
         returns (uint256[] memory amounts);
 }

 // //pragma solidity >=0.6.2;

 interface IRouter is IUniswapV2Router01 {
     function removeLiquidityETHSupportingFeeOnTransferTokens(
         address token,
         uint256 liquidity,
         uint256 amountTokenMin,
         uint256 amountETHMin,
         address to,
         uint256 deadline
     ) external returns (uint256 amountETH);

     function removeLiquidityETHWithPermitSupportingFeeOnTransferTokens(
         address token,
         uint256 liquidity,
         uint256 amountTokenMin,
         uint256 amountETHMin,
         address to,
         uint256 deadline,
         bool approveMax,
         uint8 v,
         bytes32 r,
         bytes32 s
     ) external returns (uint256 amountETH);

     function swapExactTokensForTokensSupportingFeeOnTransferTokens(
         uint256 amountIn,
         uint256 amountOutMin,
         address[] calldata path,
         address to,
         uint256 deadline
     ) external;

     function swapExactETHForTokensSupportingFeeOnTransferTokens(
         uint256 amountOutMin,
         address[] calldata path,
         address to,
         uint256 deadline
     ) external payable;

     function swapExactTokensForETHSupportingFeeOnTransferTokens(
         uint256 amountIn,
         uint256 amountOutMin,
         address[] calldata path,
         address to,
         uint256 deadline
     ) external;
 }


 // File contracts/PreSale.sol
 // SPDX-License-Identifier: MIT

 //pragma solidity ^0.8.0;

 contract DOXcoinSale is OwnerWithdrawable {
     using SafeMath for uint256;
     using SafeERC20 for IERC20;
     using SafeERC20 for IERC20Metadata;

     // pancakeswpa router
     IRouter public router;

     //Rate wrt to Native Currency of the chain
     uint256 public rate;

     // Token for which presale is being done
     address public saleToken;
     uint public saleTokenDec;

     //Total tokens to be sold in the presale
     uint256 public totalTokensforSale;

     // Whitelist of tokens to buy from
     mapping(address => bool) public tokenWL;

     // 1 Token price in terms of WL tokens
     mapping(address => uint256) public tokenPrices;

     //Time when PreSale starts
     uint256 public preSaleStartTime;

     //Time when PreSale ends
     uint256 public preSaleEndTime;

     uint256 public totalTokensSold;

     constructor() {
     }

     //modifier to check if the sale has already started
     modifier saleStarted(){
         if(preSaleStartTime != 0){
             require(block.timestamp < preSaleStartTime, "PreSale: Sale has already started. Cannot change Sale Params!");
         }
         _;
     }

     //modifier to check if the sale has ended
     modifier saleEnded(){
         if(preSaleEndTime != 0){
             require(block.timestamp < preSaleEndTime, "PreSale: Sale has already ended. Cannot change Sale Params!");
         }
         _;
     }

     //modifier to check if the sale is active or not
     modifier saleDuration(){
         require(block.timestamp > preSaleStartTime, "Presale: Sale hasn't started");
         require(block.timestamp < preSaleEndTime, "PreSale: Sale has already ended");
         _;
     }

     //modifier to check if the Sale Duration and Locking periods are valid or not
     modifier saleValid(
         uint256 _preSaleStartTime, uint256 _preSaleEndTime
     ){
         require(block.timestamp < _preSaleStartTime, "PreSale: Starting time is less than current TimeStamp!");
         require(_preSaleStartTime < _preSaleEndTime, "PreSale: Invalid PreSale Dates!");
         _;
     }

     //function to set information of Token sold in Pre-Sale and its rate in Native currency
     function setSaleTokenParams(
         address _saleToken, uint256 _totalTokensforSale, uint256 _rate
     )external onlyOwner saleStarted{
         require(_rate != 0, "PreSale: Invalid Native Currency rate!");
         rate = _rate;
         saleToken = _saleToken;
         saleTokenDec = IERC20Metadata(saleToken).decimals();
         totalTokensforSale = _totalTokensforSale;
         IERC20(saleToken).safeTransferFrom(msg.sender, address(this), totalTokensforSale);
     }

     //function to set Pre-Sale duration and locking periods
     function setSalePeriodParams(
         uint256 _preSaleStartTime,
         uint256 _preSaleEndTime
     )external onlyOwner saleStarted saleValid(_preSaleStartTime, _preSaleEndTime){

         preSaleStartTime = _preSaleStartTime;
         preSaleEndTime = _preSaleEndTime;

     }

     // Add a token to buy presale token from, with price
     function addWhiteListedToken(
         address[] memory _tokens,
         uint256[] memory _prices
     ) external onlyOwner saleEnded{
         require(
             _tokens.length == _prices.length,
             "Presale: tokens & prices arrays length mismatch"
         );

         for (uint256 i = 0; i < _tokens.length; i++) {
             require(_prices[i] != 0, "Presale: Cannot set price to 0");
             tokenWL[_tokens[i]] = true;
             tokenPrices[_tokens[i]] = _prices[i];
         }
     }

     function updateTokenRate(
         address[] memory _tokens,
         uint256[] memory _prices,
         uint256 _rate
     )external onlyOwner{
         require(
             _tokens.length == _prices.length,
             "Presale: tokens & prices arrays length mismatch"
         );

         if(_rate != 0){
             rate = _rate;
         }

         for(uint256 i = 0; i < _tokens.length; i+=1){
             require(tokenWL[_tokens[i]] == true, "Presale: Token not whitelisted");
             require(_prices[i] != 0, "PreSale: Cannot set rate as 0");
             tokenPrices[_tokens[i]] = _prices[i];
         }
     }


     // Stop the Sale
     function stopSale() external onlyOwner {
         require(block.timestamp > preSaleStartTime, "PreSale: Sale hasn't started yet!");
         if(block.timestamp < preSaleEndTime){
             preSaleEndTime = block.timestamp;
         }
     }

     // Public view function to calculate amount of sale tokens returned if you buy using "amount" of "token"
     function getTokenAmount(address token, uint256 amount)
         public
         view
         returns (uint256)
     {
         uint256 amtOut;
         if(token != address(0)){
             require(tokenWL[token] == true, "Presale: Token not whitelisted");
             // uint tokenDec = IERC20(token).decimals();
             uint256 price = tokenPrices[token];
             amtOut = amount.mul(10**saleTokenDec).div(price);
         }
         else{
             amtOut = amount.mul(10**saleTokenDec).div(rate);
         }
         return amtOut;
     }

     // Public Function to buy tokens. APPROVAL needs to be done first
     function buyToken(address _token, uint256 _amount) external payable saleDuration{
         uint256 saleTokenAmt;
         if(_token != address(0)){
             require(_amount > 0, "Presale: Cannot buy with zero amount");
             require(tokenWL[_token] == true, "Presale: Token not whitelisted");

             saleTokenAmt = getTokenAmount(_token, _amount);
             IERC20(_token).safeTransferFrom(msg.sender, address(this), _amount);
         }
         else{
             saleTokenAmt = getTokenAmount(address(0), msg.value);
         }
         require((totalTokensSold + saleTokenAmt) < totalTokensforSale, "PreSale: Total Token Sale Reached!");
         IERC20(saleToken).safeTransfer(msg.sender, saleTokenAmt);
         // Update Stats
         totalTokensSold += saleTokenAmt;
     }

 }